#!/usr/bin/wish8.5
### you may have to change this according to your Linux setup
###
### AOR_SEARCH
### utility to search, log and record
### with AOR 8200/8600 receivers
###
### release 0.96 - October 2010 
###
### (C) 2010 Stefano Sinagra IZ0MJE - www.tarapippo.net
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


## here are some parameters you don't need to change
        # initializing variables
		#these are overridden by the .ini file but may kick in in case of problems
		set bank c
		set begin 0145000000
		set end 0146000000
		set step 012500
		set n_mode 1
		set recstring "arecord -D hw:1,0 -t wav -f CD -d"
		set recstring2 "dummy"
		set recfolder "./"
		set comport "/dev/ttyS0"
		set pause 1
		set skiplistname "skip1.txt"
		set recflag 1
		set showskip 1
		set radioname "aor_search"
		set aorgreen [format "#%02x%02x%02x" 143 219 95]
		#serial port
			# Windows CE format "com1:"
			# Windows "desktop" editions (XP and older) "COM1"
		        # Linux  "/dev/ttyS0"
		        set comport "/dev/ttyS0" 
			# Mac OSX 
			#set comport "/dev/cu.usbserial-FTBUHI6Z"
		
		if {$tcl_platform(platform) eq "windows" } {set font "{Ericsson GA628}"
		} else {set font "ElectronicHighWaySign"}

		
	set logid ""
	set delay 10
        set feedback 0
        set nbr 0
	set line ""
	set debug 0
	set filename "dummy"
	set oldfreq 1
	set running 0
	set skiplist [list]
	set skiptag(0) 0

#audio recording software command string
# Linux / ALSA --	set recstring "arecord -D hw:1,0 -t wav -f CD -d $pause $filename"
# only one line is necessary
#	set recstring "arecord -D hw:1,0 -t wav -f CD -d"
#   set recstring2 ""

# Windows + HarddiskOgg Audio Capture by Fridgesoft
#set reccmd "harddisk.exe -record -nofocus -timelimit $pause -output $filename"
	set recstring "harddisk.exe -record -nofocus -timelimit "
	set recstring2	" -output "
	
### procedures
	## config file
		# read
		proc readini {} {
			global argc
			global argv
			global bank
			global begin
			global end
			global step
			global n_mode
			global recstring
			global recstring2
			global recfolder
			global comport
			global pause
			global skiplistname
			global recflag
			global showskip
			global radioname
			set filename [lindex $argv 0]
			if {$argc == 1} {set configfile [open $filename r]
			} else {set configfile [open "aor_search.cfg" r]}
			while {![eof $configfile]} {
				set line [gets $configfile]
				if {[lindex $line 0] eq "recstring"} { 
					set line [lrange $line 1 end]
					set recstring $line
				} elseif {[lindex $line 0] eq "recstring2"} { 
					set line [lrange $line 1 end]
					set recstring2 $line	
				} elseif {[lindex $line 0] eq "comport"} {
					set [lindex $line 0] [lindex $line 1]
					checkserial [lindex $line 1]
				} else {set [lindex $line 0] [lindex $line 1]}
				puts "<< config: $line"
				}
			close $configfile
			}

		# write
		proc writeini {} {
			global bank
			global begin
			global end
			global step
			global n_mode
			global recstring
			global recstring2
			global recfolder
			global comport
			global pause
			global skiplistname
			global recflag
			global showskip
			global radioname
			set configfile [open "aor_search.cfg" w]
			puts $configfile "bank $bank"
			puts $configfile "begin $begin"
			puts $configfile "end $end"
			puts $configfile "step $step"
			puts $configfile "n_mode $n_mode"
			puts $configfile "recstring $recstring"
			puts $configfile "recstring2 $recstring2"			
			puts $configfile "recfolder $recfolder"
			puts $configfile "comport $comport"
			puts $configfile "pause $pause"
			puts $configfile "skiplistname $skiplistname"
			puts $configfile "recflag $recflag"
			puts $configfile "showskip $showskip"
			puts $configfile "radioname $radioname"
			close $configfile
			puts ">> config saved"
			}

	## skip file
		# read
		proc readskip {} {
			global skiplist
			global skiptag
			global skiplistname
			set skiplist [list]
			set skipfile [open $skiplistname r]
			while {![eof $skipfile]} {
				set fields [split [gets $skipfile] ";"]
				if {[lindex $fields 2] == 1} { 
					lappend skiplist [lindex $fields 0]
				      }
				set skiptag([lindex $fields 0]) [lindex $fields 1]
				}
			puts "<< skiplist imported"
			close $skipfile
			}

		# check if freq is to be skipped
		proc chkskip {aaa} {
			global skiplist
			set aaa [khz $aaa]
			if {[lsearch -exact $skiplist $aaa] == -1 } {
				return 0 } else { return 1 }
			} 

        ## serial port setup
                # serial port open
                proc seropen {} {
                        global serial ;
                        global comport ;
                        set serial [open $comport r+]
                        fconfigure $serial -mode "19200,n,8,1"
                        fconfigure $serial -blocking 0 -buffering none
			 }

                # serial port close
                proc serclose {} { 
	                global serial ;
	                close $serial ; }

        # convert Hz in kHz and viceversa
        proc khz {aaa} { 
		regsub ^0+(.+) $aaa \\1 aaa
		set aaa [format "%0.3f" $aaa]
		set aaa [expr $aaa / 1000]
		return $aaa
		}

        proc hz {aaa} { 
		set aaa [expr $aaa * 1000]
		set aaa [format "%010.f" $aaa]
		return $aaa
		}

        proc s_hz {aaa} { 
		set aaa [expr $aaa * 1000]
		set aaa [format "%06.f" $aaa]
		return $aaa
		}
	

        ## procedure to send commands
        proc radiocmd { command } {
             global serial ;
             global feedback ;
             global delay
	     global debug
		puts $serial $command
		if {$debug == 1} {.textarea.txt insert end ">>> $command\n"}
        	flush $serial ;
            	after $delay ;
             	set feedback [read $serial] ; 
		if {$debug == 1} {.textarea.txt insert end "<<< $feedback\n"}
		}

	## procedure to set search parameters
        proc setsrch {} {
                global begin
                global end 
                global step
		global bank
		global n_mode
		global pause
		global running
		if { $running == 1 } {
			.but2 invoke
			set running 0
			}
		#send new settings to radio
		#radiocmd "GS9 SD01 SP1 BS%%$bank"
		radiocmd "GS9 SD01 SP1 BS%%"
#		radiocmd "SE$bank SL$begin SU$end AU0 ST$step MD$n_mode TTAOR_SEARCH"
		radiocmd "SE$bank SL$begin SU$end AU0 ST$step MD$n_mode"
		.textarea.txt insert end "--- parameters changed ---\n"
		.textarea.txt see end
		}

        ## check if serial port format is good for OS
        proc checkserial { serstring } {
		global tcl_platform
		set opsys $tcl_platform(platform)
		string toupper comstart
		string trim $opsys
		puts "## Detected OS: $opsys -- Serial port configured in inifile as: $serstring"
		puts "## this is the first thing to check if script fails to start"
		}


# options set sub-window
        proc options {} {
                global comport
		global recstring
		global recstring2
		global recfolder
		global recflag
		global running
		global showskip

                toplevel .messpop1
                grab .messpop1
                wm title .messpop1 "Software Options"

                label .messpop1.tty_lab -text "Serial port:"
                entry .messpop1.tty_ent -width 25
                .messpop1.tty_ent insert 0 "$comport"

                label .messpop1.rec_lab -text "Record cmd:"
                entry .messpop1.rec_ent -width 25
                label .messpop1.rec_lab2 -text "<length>"		
                entry .messpop1.rec_ent2 -width 25
                label .messpop1.rec_lab3 -text "<filename>"
                .messpop1.rec_ent insert 0 "$recstring"
                .messpop1.rec_ent2 insert 0 "$recstring2"
                
                label .messpop1.recf_lab -text "Recording folder:"
                entry .messpop1.recf_ent -width 25 -textvariable $recfolder
                .messpop1.recf_ent delete 0 end
                .messpop1.recf_ent insert 0 "$recfolder"
				button .messpop1.but1 -text "Select" -command {
					global recfolder
					set $recfolder [tk_chooseDirectory -initialdir $recfolder -title "Choose a directory"] 
				} -width 10 


		checkbutton .messpop1.rec_chk -text "Audio capture" -variable recflag
		checkbutton .messpop1.shw_skp -text "Show skipped channels" -variable showskip

                button .messpop1.okb2 -text "Ok" -command {
			     	     if { $running == 1 } {.but2 invoke}
				     set comport [.messpop1.tty_ent get]
				     serclose
				     seropen
				     set recstring [.messpop1.rec_ent get]
				     set recstring2 [.messpop1.rec_ent2 get]
				     set recfolder ""
				     set recfolder [.messpop1.recf_ent get]
				     writeini
        	         destroy .messpop1
				     .textarea.txt insert end "--- options changed ---\n"
	    			 .textarea.txt see end
				     set running 0
                                     }
                button .messpop1.okb -text "Cancel" -command {destroy .messpop1 ; return 0}

		
                grid .messpop1.tty_lab -in .messpop1 -row 1 -column 1
                grid .messpop1.tty_ent -in .messpop1 -row 1 -column 2
                grid .messpop1.rec_lab -in .messpop1 -row 2 -column 1
                grid .messpop1.rec_ent -in .messpop1 -row 2 -column 2
                grid .messpop1.rec_lab2 -in .messpop1 -row 2 -column 3
                grid .messpop1.rec_ent2 -in .messpop1 -row 2 -column 4
                grid .messpop1.rec_lab3 -in .messpop1 -row 2 -column 5
                grid .messpop1.recf_lab -in .messpop1 -row 3 -column 1
                grid .messpop1.recf_ent -in .messpop1 -row 3 -column 2
				grid .messpop1.but1 -in .messpop1 -row 3 -column 3
                grid .messpop1.rec_chk -in .messpop1 -row 4 -column 1		
				grid .messpop1.shw_skp -in .messpop1 -row 4 -column 2
                grid .messpop1.okb2 -in .messpop1 -row 6 -column 3
                grid .messpop1.okb -in .messpop1 -row 6 -column 4
                }

             	 	
        ## fired by file event
	proc recieveData { chan } {
	     global line
	     global recstring
	     global recstring2
	     global recfolder
	     global pause
	     global debug
	     global oldfreq
	     global logid
	     global recflag
	     global skiptag
	     global showskip
	     if { [eof $chan] } {
        	catch {close $chan}
	        return
		}
		set timestamp [clock format [clock seconds] -format "%Y%m%d-%H%M%S"]
		set s_timestamp [clock format [clock seconds] -format "%e %b %Y %H:%M:%S"]
		set frequency ""
		set signal 0
		set data [read $chan]
		set l_length [string length $data]  
		set line "$line$data"
		set pippo [string range $data [expr $l_length -1] end]
		if { $pippo eq "\n"  } {
			regexp -all {\d{10}} $line frequency
			if {($frequency ne "") && ($frequency ne $oldfreq)} {
				if { [chkskip $frequency] == 1 } {
				   if {$showskip == 1} {	    
				        set frequency [khz $frequency]
				        set label $skiptag($frequency)
				        .textarea.txt insert end "   Skipping $frequency = $label\n"
				        .textarea.txt see end
					}
				   } else {
				radiocmd "SDFF"
				set oldfreq $frequency
				scan $oldfreq %d tagfreq
				set frequency [khz $frequency]
				.textarea.txt insert end "$s_timestamp "
				.textarea.txt insert end "$frequency "
				regexp -all {LC%?\d{3}} $line signal
				regsub {LC%?} $signal "" signal
				.textarea.txt insert end "$signal"
				if {[info exists skiptag($tagfreq)]} {
					.textarea.txt insert end " = $skiptag($tagfreq) "
				      }
				.textarea.txt insert end "\n"
				.textarea.txt see end
				puts $logid "$frequency; $timestamp; $signal"
				regsub {\.} $frequency "" frequency
				if { $recflag == 1 } {
					set filename "$recfolder/$frequency-$timestamp.wav"
					set reccmd "$recstring $pause $recstring2 $filename"
					if { $debug > 0} {puts $reccmd}
					eval exec -ignorestderr $reccmd &
					}
				after [expr $pause * 1000]
				radiocmd "SD00"
				}
			      }
			set line ""
			}
		}	


# parameters set sub-window
        proc params {} {
                global begin
                global end 
                global step
		global bank
		global n_mode
		global pause
		global running
		
                toplevel .messpop
                grab .messpop
                wm title .messpop "Input Search Parameters"

                label .messpop.stf_lab -text "Start (kHz):"
                entry .messpop.stf_ent -width 8
                .messpop.stf_ent insert 0 "[khz $begin]"

                label .messpop.spf_lab -text "Stop (kHz):"
                entry .messpop.spf_ent -width 8
                .messpop.spf_ent insert 0 "[khz $end]"

                label .messpop.stp_lab -text "Step (kHz):"
                entry .messpop.stp_ent -width 4
                .messpop.stp_ent insert 0 "[khz $step]"

                label .messpop.bnk_lab -text "Bank:"
                entry .messpop.bnk_ent -width 4
                .messpop.bnk_ent insert 0 "$bank"


	label .messpop.lbl -text "Mode:"
	radiobutton .messpop.wfm -text "WFM" -variable n_mode -value 0
	radiobutton .messpop.nfm -text "NFM" -variable n_mode -value 1
	radiobutton .messpop.am  -text "AM "  -variable n_mode -value 2
	radiobutton .messpop.usb -text "USB" -variable n_mode -value 3
	radiobutton .messpop.lsb -text "LSB" -variable n_mode -value 4
	radiobutton .messpop.cw  -text "CW "  -variable n_mode -value 5
	radiobutton .messpop.sfm -text "SFM" -variable n_mode -value 6
	radiobutton .messpop.wam -text "WAM" -variable n_mode -value 7
	radiobutton .messpop.nam -text "NAM" -variable n_mode -value 8
	grid .messpop.lbl -in .messpop -row 3 -column 1
	grid .messpop.wfm -in .messpop -row 4 -column 1
	grid .messpop.nfm -in .messpop -row 4 -column 2
	grid .messpop.am -in .messpop -row 4 -column 3
	grid .messpop.usb -in .messpop -row 5 -column 1
	grid .messpop.lsb -in .messpop -row 5 -column 2
	grid .messpop.cw -in .messpop -row 5 -column 3
	grid .messpop.sfm -in .messpop -row 6 -column 1
	grid .messpop.wam -in .messpop -row 6 -column 2
	grid .messpop.nam -in .messpop -row 6 -column 3
                
	      label .messpop.pau_lab -text "Pause:"
          entry .messpop.pau_ent -width 4
          .messpop.pau_ent insert 0 "$pause"

                button .messpop.okb2 -text "Ok" -command {
	               	set begin [hz [.messpop.stf_ent get]]
	                set end [hz [.messpop.spf_ent get]]
	       	        set step [s_hz [.messpop.stp_ent get]]
			set bank [.messpop.bnk_ent get]
			set pause [format "%02.f" [.messpop.pau_ent get]]
			setsrch
			writeini
        	        destroy .messpop
                        }
                button .messpop.okb -text "Cancel" -command {destroy .messpop ; return 0}
		
                grid .messpop.stf_lab -in .messpop -row 1 -column 1
                grid .messpop.stf_ent -in .messpop -row 1 -column 2
                grid .messpop.spf_lab -in .messpop -row 1 -column 3
                grid .messpop.spf_ent -in .messpop -row 1 -column 4
                grid .messpop.stp_lab -in .messpop -row 2 -column 1
                grid .messpop.stp_ent -in .messpop -row 2 -column 2
                grid .messpop.bnk_lab -in .messpop -row 2 -column 3
                grid .messpop.bnk_ent -in .messpop -row 2 -column 4
                grid .messpop.pau_ent -in .messpop -row 7 -column 2
                grid .messpop.pau_lab -in .messpop -row 7 -column 1
                grid .messpop.okb2 -in .messpop -row 8 -column 3
                grid .messpop.okb -in .messpop -row 8 -column 4
                }


# skiplist selection sub-window
        proc skiplistselect {} {
		global running
		if { $running == 1 } {
			.but2 invoke
			set running 0
			}
                global skiplistname
		set skiplistname [tk_getOpenFile -initialfile $skiplistname]
		if {$skiplistname != "" } {
			writeini
			readskip 
			}
		}

# About message
        proc about {} {
                toplevel .messpop2
                grab .messpop2
                wm title .messpop2 "About"

                label .messpop2.uno -text "aor_search v0.90"
                label .messpop2.due -text "(c) 2010 Stefano Sinagra IZ0MJE www.tarapippo.net"
                label .messpop2.tre -text "released under GNU/GPL v3 license"		
                button .messpop2.okb -text "Ok" -command {destroy .messpop2 ; return 0}
		
                grid .messpop2.uno -in .messpop2 -row 1 -column 1
                grid .messpop2.due -in .messpop2 -row 2 -column 1
                grid .messpop2.tre -in .messpop2 -row 3 -column 1
                grid .messpop2.okb -in .messpop2 -row 4 -column 1
                }



#========== GUI ============


#main window
wm title . $radioname
frame .master -width 480 -height 640
frame .buts -relief groove
frame .display -relief groove

# display
frame .textarea
text .textarea.txt -font "$font 10" -width 60 -height 12 -bg $aorgreen -yscrollcommand ".textarea.srl_y set" -wrap none
grid .textarea.txt -in .textarea -row 1 -column 1 -sticky nsew
grid rowconfigure .textarea 0 -weight 1
grid columnconfigure .textarea 0 -weight 1		
scrollbar .textarea.srl_y -command ".textarea.txt yview" -orient v
grid .textarea.srl_y -in .textarea -row 1 -column 2 -sticky nsew
grid .textarea -in .display -row 1 -column 1
pack .textarea

# buttons
set keyfont "Tahoma 12"

					
button .but1 -text "search" -command {
			global running
			global logid
			global serial
			setsrch
			fileevent $serial readable [list recieveData $serial]
			set timestamp [clock format [clock seconds] -format "%Y%m%d"]
			regsub {\s} $timestamp "" timestamp
			set logid [open "aors-log-$timestamp.txt" "a+"] ;
			radiocmd "SS$bank"
			set running 1
			.textarea.txt insert end "--- START ---\n"
			} -width 10 
grid .but1 -in .buts -column 1 -row 1

button .but2 -text "stop" -command {
			global running
			global logid
			if {$running == 1 } {
				close $logid
				radiocmd "VF"
				radiocmd "EX"
				}
			set running 0
			.textarea.txt insert end "--- STOP ---\n"
			} -width 10 
grid .but2 -in .buts -column 2 -row 1

button .but3 -text "quit" -command {
			global running
			global logid
			if {$running == 1} {
				catch close $logid
				radiocmd "VF"
				radiocmd "EX"
				serclose
				}
			exit
			} -width 10 
grid .but3 -in .buts -column 3 -row 1

button .but4 -text "parameters" -command params -width 10 
grid .but4 -in .buts -column 1 -row 2

button .but5 -text "options" -command options -width 10
grid .but5 -in .buts -column 2 -row 2

button .but6 -text "skiplist" -command skiplistselect -width 10
grid .but6 -in .buts -column 3 -row 2

button .but7 -text "about" -command about -width 10
grid .but7 -in .buts -column 4 -row 2

grid .display -in .master -row 1 -column 1 
grid .buts -in .master -row 2 -column 1 
pack .master

#========== GUI END =========================

#####
###
## this is the main procedure

readini
readskip
seropen

